this.pic = null;
this.frame = null;
this.tree = null;
this.up = null;
this.x = 0;
this.y = 0;
this.w = 0;
this.h = 0;
this.w0 = 100;
this.h0 = 100;
//this.titleField = null;
this.titleNode = null;

this.enlargeM = 1;
this.enlargeCorner = 0xC0C0C0;
this.isMovie = false;
this.slides = new Array ();

function init (pa, curTeg) {
	tree = curTeg;
	up = pa;
	if (tree.attributes.id_ref != undefined) tree.attributes.notCollect = true;
	if ((tree.attributes.noFrame == true) && (tree.attributes.notEnlarge == undefined)) tree.attributes.notEnlarge = true;
	if (tree.attributes.enlargeScale != undefined) enlargeM = tree.attributes.enlargeScale;
	if (tree.attributes.snapshot == undefined) load ();
		else loadSnapshot (tree.attributes.snapshot);
}	
	
function load () {
	if (tree.attributes.src != undefined) loadSnapshot (tree.attributes.src);
}

function loadSnapshot (fileName0) {
	var fileName = fileName0;
	switch (fileName.substr(-4, 4)) {
		case ".swf":	
			if (_global.builder_version >= 2) fileName = "..\\..\\MODELERS\\" + fileName; // v2
			pic = new Flash ();
			pic.playing = true; 
			break;			
		case ".gif":	
			pic = new Animation ();
			pic.playing = pic.loop = true; 
			break;			
		default: // ,      
			pic = new Image ();
			++ _global.restToLoad;
			pic.onLoad = function () { if (--_global.restToLoad == 0) _level0.endOfLoad() }			
	}
	pic.src = _level0.SETUP_PATH_media + fileName;
	pic.frame__depth = --up.wasDepth;
	pic.depth = --up.wasDepth;
	pic.parent = this;
}
	
function preparePic () {
	setPicSize ();
}

function decor () { 
	if (pic == null) return;
	if (tree.attributes.visible == false) { // v2
		if (this.pic.ST_DISABLED != undefined) this.pic.enabled = false;
		else { 
			this._visible = false;	
			this.opacity = 0;
		}
	}
	if (tree.attributes.noFrame != true) {
		frame = new Composition ();
		frame.depth = pic.frame__depth;
		with (frame) {
			_class = "ui_CFrame";
			border = 22;
			x = -15;
			y = -15;
			parent = this;
			imSkin.src = _level0.SETUP_PATH_img + "frame.png";
			resize (pic.width + 2 * _level0.SETUP_ELEM_frame, pic.height + 2 * _level0.SETUP_ELEM_frame);
		}
	}
	if (tree.attributes.notEnlarge != true) {
		useHandCursor = false;
		onRollOver = function () {
			if (_root.skinLetter == "V") {
				scene.SND_copied.src = "/DATA/skin/sounds/enlarge.mp3";
				scene.SND_copied.rewindAndPlay();				
			}
			with (this.lupa) crop (0, 0, width, height);		
			lupa.show();
		}
		onRollOut = function () {
			lupa.hide();
		}
		onPress = function () {
			with (lupa) crop (0, height, width, height);		
		}
		onRelease = function () {
			onRollOver ();
			tryEnlarge ();
		}
	}
}

function title_ () { 
	var titles = tree.childNodes;
	for (var titleN=0; titleN < titles.length; titleN++) {
		var tn = titles.item(titleN);
		
		switch (tn.nodeName) {
		case "title":
			titleNode = tn;
			if (tn.attributes.hide == true) break;
			if (tn.attributes.width == undefined) {
				tn.attributes.width = pic._width;
				tn.attributes.x = 0;
				tn.attributes.y = pic._height+_level0.SETUP_ELEM_dyTitle;
				if (_global.module_version >= 2) if (tree.attributes.noFrame == true) tn.attributes.y -= 10; // v2
			}
			if (tn.attributes.align == undefined)			
				tn.attributes.align = (_level0.myModule.tree.attributes.default_align == undefined) ? "right" : _level0.myModule.tree.attributes.default_align;	
			var textWasCreated = _level0.textWrite (_level0.XMLcontentToString (tn), tn.attributes.x, tn.attributes.y + 5, 
				tn.attributes.width, "ST_element_title", tn.attributes.align, this);
			textWasCreated.depth = this.pic.depth;
			break;
		case "slide":
			this.slides.push (tn);
			break;
		}
	}		
}
	
function setPicSize () {
	if (pic == null) return;
	if (tree.attributes.width == undefined) {
		if (tree.attributes.height == undefined) {
			pic.wasAutosized = true;
			tree.attributes.width = pic.width;
			tree.attributes.height = pic.height;
			
			var mwh = Math.min (_level0.SETUP_SCR_w / tree.attributes.width, 
								_level0.SETUP_SCR_h / tree.attributes.height);
			if (mwh < 1) {
				tree.attributes.width *= mwh;
				tree.attributes.height *= mwh;
			}
			
		} else tree.attributes.width = pic.width / pic.height * tree.attributes.height;
	} else if (tree.attributes.height == undefined) tree.attributes.height = pic.height / pic.width * tree.attributes.width;
	
	w0 = pic.width;
	h0 = pic.height;
	
	pic.width = Math.round(tree.attributes.width);
	pic.height = Math.round(tree.attributes.height);
	
	if (tree.attributes.x == undefined) tree.attributes.x = 0;
	x = tree.attributes.x;
	if (tree.attributes.y == undefined) tree.attributes.y = 0;	
	y = tree.attributes.y;
}

function tryEnlarge () {
	if (tree.attributes.id_ref != undefined) {
		_level0.gotoRef (tree.attributes.id_ref);
		return;
	}
	_level0.playSound ();
	var pageEnlarge = _level0.myModule.pageEnlarge;
	pageEnlarge.i = pageEnlarge.c = undefined;
	pageEnlarge.cycling = (tree.attributes.cycling == true);
	pageEnlarge.noButton = ! isMovie || (tree.attributes.noButton == true);
	pageEnlarge.largePic = undefined;
	if ((this.slides.length > 0) && (_level0.currentSlideN == 0)) _level0.currentSlideN = 1;
	
	with (pageEnlarge) {
		var attributes = (_level0.currentSlideN == 0) ? tree.attributes : this.slides[_level0.currentSlideN - 1].attributes;
		var fileName = attributes.src;
	
		switch (fileName.substr(-4, 4)) {
			case ".swf":	
				largePic = largeFlash;
				if (_global.builder_version >= 2) fileName = "..\\..\\MODELERS\\" + fileName; // v2
				break;			
			case ".gif":	
				largePic = largeAnimation;
				break;			
			case ".avi":	
			case ".mpg":	
			case ".mpeg":	
			case ".mp4":	
				largePic = largeVideo;
				break;			
			default:
				largePic = largeImage;
		}
		if (largePic.src != (_level0.SETUP_PATH_media + fileName)) {
			largePic.hasPanorama = false;
			largePic.panoramaMinM = (_root.skinLetter == "V") ? 0.5 : enlargeM;
			largePic.panoramaMaxM = (_root.skinLetter == "V") ? 2 : enlargeM;
			largePic.src = _level0.SETUP_PATH_media + fileName;
			_level0.currentMashtab = 0;
		}
		var wasNotResized = (_level0.currentMashtab == 0);
		if (wasNotResized) _level0.currentMashtab = enlargeM;

		if (largePic.gotoAndStop != undefined) largePic.gotoAndStop (0);
		largePic.show();
		
		largePic.elemEnlarged = this;
		
		var picMedia = largePic.getMediaSize ();
		var w_ = picMedia.width * _level0.currentMashtab;
		var h_ = picMedia.height * _level0.currentMashtab;
		if (w_ * h_ == 0) return;
		
		if (((_root.skinLetter != "V") && (_global.module_version <= 2)) || _level0.currentFitPage) {
			var mw = _level0.SETUP_LARGE_wMax / w_;
			var mh = _level0.SETUP_LARGE_hMax / h_;
			var m = Math.min (Math.min (mw, mh), 1);
			w_ *= m;
			h_ *= m;
			_level0.currentMashtab *= m;
			if (wasNotResized) enlargeM = _level0.currentMashtab;
 			_level0.currentCenterX = _level0.currentCenterY = 0;
 			_level0.currentFitPage = false;
 		}
		
		var cropW = Math.min (_level0.SETUP_LARGE_wMax, w_);
		var cropH = Math.min (_level0.SETUP_LARGE_hMax, h_);

		_level0.currentCenterX = Math.min (Math.max (_level0.currentCenterX, (cropW - w_) / 2), (w_ - cropW) / 2);
		_level0.currentCenterY = Math.min (Math.max (_level0.currentCenterY, (cropH - h_) / 2), (h_ - cropH) / 2);
		var x_0 = (1024 - _level0.SETUP_LARGE_wMax - _level0.SETUP_LARGE_title_h) / 2; // 1024 -   
		var y_0 = (_level0.SETUP_SCR_h - _level0.SETUP_LARGE_hMax - _level0.SETUP_LARGE_title_h) / 2;
		var x__ = (1024 - w_ - _level0.SETUP_LARGE_title_h) / 2 - _level0.currentCenterX; // 1024 -   
		var y__ = (_level0.SETUP_SCR_h - h_ - _level0.SETUP_LARGE_title_h) / 2 - _level0.currentCenterY;
		
		var cropX = (Math.max (x_0 - x__, 0));
		var cropY = (Math.max (y_0 - y__, 0));
		
		if (largePic != largeFlash)
		largePic.crop (Math.round(cropX / _level0.currentMashtab), Math.round(cropY / _level0.currentMashtab), 
			Math.round(cropW / _level0.currentMashtab), Math.round(cropH / _level0.currentMashtab));
			
		x__ += cropX;
		y__ += cropY;
		
		largePic.x = x__;
		largePic.y = y__;
		largePic.width = Math.round(cropW);
		largePic.height = Math.round(cropH);		
		w_ = cropW;
		h_ = cropH + _level0.SETUP_LARGE_title_h;
		
		if ((largePic == largeFlash) && largePic.hasPanorama) {
			var val = '' + (cropX/_level0.currentMashtab) + '|' + (cropY/_level0.currentMashtab) + '|' + 
				(largePic.width/_level0.currentMashtab) + '|' + (largePic.height/_level0.currentMashtab);
			var out=largePic.callFunction("<invoke name='panorama' returntype='xml'><arguments><string>"+val+"</string></arguments></invoke>");
		}
		
		pageEnlarge.x_ = x__ - _level0.SETUP_LARGE_frame;
		pageEnlarge.y_ = y__ - _level0.SETUP_LARGE_frame;
		pageEnlarge.w = w_ + 2 * _level0.SETUP_LARGE_frame + _level0.SETUP_LARGE_title_h;
		pageEnlarge.h = h_ + 2 * _level0.SETUP_LARGE_frame;

		if ((_level0.currentSlideN != 0)) {
			i = _level0.XMLtoString (this.slides[_level0.currentSlideN - 1].firstChild);
		} else if (titleNode != undefined) {
			i = _level0.XMLtoString (titleNode);
			var title_arr = i.split("<");
			i = "";
			for (var title_i = 0; title_i < title_arr.length; ++title_i) 
				if (title_arr[title_i].split(">").length > 1) i += title_arr[title_i].split(">")[1];	
		}
		if (i == "") i = undefined;
		if (i != undefined) {
			txt_i.x = x__;
			txt_i.y = y__ + h_ - 40;
			txt_i.width = w_;
			txt_i.value = i;
			txt_i.onRelease = function () {
				_level0.copyToClipboard (this);
			}
		}
		txt_i.visible = (i != undefined);
		
		c = attributes.copyright;
		if ((c != undefined) && (c != "")) {
			txt_c.x = x__;
			txt_c.y = txt_i.y;
			txt_c.width = w_;
			txt_c.value = String.fromCharCode(169) + c;
			txt_c.onRelease = function () {
				_level0.copyToClipboard (this);
			}
		}
		txt_c.visible = false;

		if ((i != undefined) && (c != undefined)) {
			copyrightButton.x = x__ - _level0.SETUP_LARGE_frame + w_ + 35;
			copyrightButton.y = y__ - _level0.SETUP_LARGE_frame + h_ - 20;
			copyrightButton.show();
			copyrightButton.c.show();
			copyrightButton.i.hide();
			copyrightButton.c.onRelease = function () {
				this.hide();
				this.parent.i.show();
				var pageEnlarge = this.parent.parent;
				pageEnlarge.txt_i.hide();
				pageEnlarge.txt_c.show();
				_global.setFocus(pageEnlarge.largePic);
			}
			copyrightButton.i.onRelease = function () {
				this.hide();
				this.parent.c.show();
				var pageEnlarge = this.parent.parent;
				pageEnlarge.txt_c.hide();
				pageEnlarge.txt_i.show();
				_global.setFocus(pageEnlarge.largePic);
			}		
		} else {
			copyrightButton.hide();
		}
	
		copypasteButton.x = x__ - _level0.SETUP_LARGE_frame + w_ + 35;
		copypasteButton.y = y__ + 45;
		copypasteButton.onRelease = function () {
			_level0.copyToClipboard (largePic);
		}

		playButton.play.onRelease = function () {
			this.hide();
			this.parent.stop.show();
			this.parent.parent.largePic.play();
			_global.setFocus(this.parent.parent.largePic);
		}
		playButton.stop.onRelease = function () {
			this.hide();
			this.parent.play.show();
			if (isMovie) this.parent.parent.largePic.stop();
			_global.setFocus(this.parent.parent.largePic);
		}
		largePic.onPlayed = function () {
			this.rewind();
			if (! this.parent.cycling) this.parent.playButton.stop.onRelease();
				else this.play(); //        2- 				
		}
		if (isMovie) largePic.rewind();
		if (! noButton) {
			playButton.show();
			playButton.stop.show();
			playButton.play.hide();
			playButton._x = x__ - _level0.SETUP_LARGE_frame + w_ + 35;
			playButton._y = y__ - _level0.SETUP_LARGE_frame + h_ - 80;
		} else {
			playButton.hide();
		}

		if (_level0.currentMashtab < enlargeM) {
			copyrightButton.hide();
			pageEnlarge.txt_i.hide();
			pageEnlarge.txt_c.hide();
		}
		
		if (isMovie) largePic.play();
		
		if (this.slides.length > 0) {
			prevButton.visible = (_level0.currentSlideN != 1);
			if (prevButton.visible) {
				txt_i.x += 45;
				txt_c.x += 45;
				txt_i.width -= 45;
				txt_c.width -= 45;
			}
			nextButton.visible = (_level0.currentSlideN != this.slides.length);
			if (nextButton.visible && copyrightButton.visible) {
				copyrightButton.x -= 43;
				txt_i.width -= 43;
				txt_c.width -= 43;
			}
			prevButton.x = x__;
			nextButton.x = x__ - _level0.SETUP_LARGE_frame + w_ + 35;
			prevButton.y = nextButton.y = y__ - _level0.SETUP_LARGE_frame + h_ - 20;
			prevButton.elemEnlarged = nextButton.elemEnlarged = this;
			prevButton.onRelease = function () {
				_level0.currentSlideN = - (_level0.currentSlideN - 1);
				_level0.currentMashtab = (_level0.currentMashtab > enlargeM) ? (- _level0.currentMashtab) : 0 ;
				_level0.currentFitPage = true;
				this.parent.closeButton.fireEvent ("onRelease");
				this.parent.closeButton.fireEvent ("onRollOut");
				this.elemEnlarged.tryEnlarge();
			}
			nextButton.onRelease = function () {
				_level0.currentSlideN = - (_level0.currentSlideN + 1);
				_level0.currentMashtab = (_level0.currentMashtab > enlargeM) ? (- _level0.currentMashtab) : 0 ;
				_level0.currentFitPage = true;
				this.parent.closeButton.fireEvent ("onRelease");
				this.parent.closeButton.fireEvent ("onRollOut");
				this.elemEnlarged.tryEnlarge();
			}
		} else {
			prevButton.visible = nextButton.visible = false;
		}
		up.x = down.x = x__ + cropW / 2 - 22;
		up.y = y__ - 17;
		down.y = y__ + cropH - 27;
		left.x = x__ - 17;
		right.x = x__ + cropW - 27;
		left.y = right.y = y__ + cropH / 2 - 22;
		plus.x = minus.x = copypasteButton.x;
		plus.y = copypasteButton.y + 45;
		minus.y = plus.y + 45;
		up.visible = cropY >= 1;
		left.visible = cropX >= 1;
		down.visible = (cropY + cropH) < (picMedia.height * _level0.currentMashtab - 1);
		right.visible = (cropX + cropW) < (picMedia.width * _level0.currentMashtab - 1);
		plus.visible = (_global.module_version >= 3) && (_level0.currentMashtab < largePic.panoramaMaxM);
		minus.visible = _level0.currentMashtab > largePic.panoramaMinM;
		
		if ((up.visible || left.visible || down.visible || right.visible) && (largePic != largeFlash)) {
			largePic.onPress = function () {
				var xm = this.xMouse;
				var ym = this.yMouse;
				this.onMouseMove = function () {					
					_level0.currentCenterX -= cropX;
					_level0.currentCenterY -= cropY;		 
					cropX -= this.xMouse - xm;
					cropY -= this.yMouse - ym;
					xm = this.xMouse;
					ym = this.yMouse;
					cropX = Math.max (Math.min (cropX, picMedia.width * _level0.currentMashtab - cropW), 0);
					cropY = Math.max (Math.min (cropY, picMedia.height * _level0.currentMashtab - cropH), 0);					
					_level0.currentCenterX += cropX;
					_level0.currentCenterY += cropY;		
					this.crop (Math.round(cropX / _level0.currentMashtab), Math.round(cropY / _level0.currentMashtab), 
						Math.round(cropW / _level0.currentMashtab), Math.round(cropH / _level0.currentMashtab));
					this.width = Math.round(cropW);
					this.height = Math.round(cropH);		
					this.parent.up.visible = cropY >= 1;
					this.parent.left.visible = cropX >= 1;
					this.parent.down.visible = (cropY + cropH) < (picMedia.height * _level0.currentMashtab - 1);
					this.parent.right.visible = (cropX + cropW) < (picMedia.width * _level0.currentMashtab - 1);
				}
				this.onRelease = this.onReleaseOutside = function () {
					this.onMouseMove = null;
					this.onRelease = null;
					this.onReleaseOutside = null;
				}
			}
			largePic.useHandCursor = true;
		} else {
			largePic.useHandCursor = false;
			largePic.onPress = null;
		}
		
		largePic.onKeyDown = function () {
			this.parent.onKeyDownEx (_global.Key.keyCode);
		}

		_global.setFocus(largePic);
	}

	_level0.text_trim (pageEnlarge);
	var sp = _level0.myModule.shownPages;
	sp[sp.length-1].enabled = false;
	pageEnlarge.show();
	sp.push (pageEnlarge);
	_level0.myModule.toolbar.enabled = false;
}
