function init (pa, curTeg) {
	this.s_active = true;
	Elem_init (pa, curTeg);
	_level0.myModule.tableThings.push (this);	
}

function load () {
	tree.attributes.notEnlarge = true;
	if (tree.attributes.noFrame != false) tree.attributes.noFrame = true;
	if (sys_param("class") != null) tree.attributes.src = sys_param("class");
	if (tree.attributes.src.indexOf(".") == -1) {
		pic = new Composition ();
		pic._class = tree.attributes.src;
		pic.depth = --up.wasDepth;
		pic.parent = this;
	}
	else {
		Elem_load ();
	}
	if (sys_param("enabled") == "false") this.enabled = false // v4a
}

function decor () {
	Elem_decor ();
	this.x00 = this._x;
	this.y00 = this._y;
	this.d00 = this.depth;

	this.setInterval ("onEnterFrame1()", 100);
	this.id = tree.attributes.id;
}

function onEnterFrame1 () {
	if (_global.restToLoad != 0) return;
	if (this.inited == undefined) {
		this.inited = true;
		this._xscale = this._yscale = 1;
		if (this.pic.$init) this.pic.$init ();
		if (this.pic.reset) this.pic.reset ();
 	}
	if (this.t_alpha != undefined) { //  
		if (this.t_alpha == 1) this._visible = true;
		if (Math.abs(this.t_alpha - this.opacity) <= _level0.SETUP_THING_aStep) {
			this.opacity = this.t_alpha;
			this.t_alpha = undefined;
			if (this.opacity == 0) this._visible = false;
		} else {
			if (this.t_alpha > this.opacity) this.opacity += _level0.SETUP_THING_aStep;
				else this.opacity -= _level0.SETUP_THING_aStep;
		}
	}
		
	if (this.t_y != undefined) { //     y
		var l = Math.sqrt (Math.pow(this.t_x - this._x, 2) + Math.pow(this.t_y - this._y, 2));
		if (((this.t_x - this._x) * this.d_x) < 0) this.d_y = undefined; //  -
		if (((this.t_y - this._y) * this.d_y) < 0) this.d_y = undefined;
		if (this.d_y == undefined) { //     y
			this.d_x = _level0.SETUP_THING_xStep * (this.t_x - this._x) / l;
			this.d_y = _level0.SETUP_THING_xStep * (this.t_y - this._y) / l;
			this.xDouble = this._x;
			this.yDouble = this._y;
		}
		if (l <= _level0.SETUP_THING_xStep) {
			this._x = this.t_x;
			this._y = this.t_y;
			this._xscale = this._yscale = 1;
			this.d_y = undefined;
			this.t_y = undefined;
			this.depth = this.d00;
		} else {
			this.xDouble += this.d_x;
			this.yDouble += this.d_y;
			this._x = this.xDouble;
			this._y = this.yDouble;
			this._xscale = this._yscale = 1;
		}
	}
}

function sys_param (name_) { // sys_param () -    LF
	var all_params = "";

	var xmlChilds = this.tree.childNodes;
	if (xmlChilds) for (var i = 0; i < xmlChilds.length; ++i) {
		var nod = xmlChilds.item(i);
		if (nod.nodeName != "param") continue;
		if ((name_ == null) || (name_ == nod.attributes["name"]))
			if (nod.childNodes) if (nod.firstChild != null) all_params += "\n" + nod.firstChild.nodeValue;
	}
	if (all_params != "") return (all_params.substring(1));
	return (null);
}

function sys_id (sid0) { // id from sid
	if (sid0 == null) return (null);
	return (sid0 + this.tree.attributes.sid_tail);
}

function sys_sid(id0) { // sid from id
	if (id0 == null) return (null);
	return (id0.substring(0, id0.indexOf("#")));
}

function $th (id0) {
	for (var rp in _level0.myModule.tableThings)
		if (_level0.myModule.tableThings[rp].tree.attributes.id == id0) return (_level0.myModule.tableThings[rp]);
	return (null);
}

function $ths (sid0) {
	return ($th (sys_id (sid0)));
}

function $go (sid_where) {
	$go_byObject ($ths(sid_where));
}

function $go_byObject (opT) {
	this.t_x = opT._x + (opT.width - this.width) / 2;
	this.t_y = opT._y + (opT.height - this.height) / 2;
	this.d_y = undefined;
	this.depth = - this.up.movingThingDepth;
}

function $drag() {
	this.useHandCursor = true;
	this.onPress = function() {
		this.depth = - this.up.thingDepth;
		this.mouseX = this.xMouse;
		this.mouseY = this.yMouse;
		this.mouseXstartdrag = parent.xMouse;
		this.mouseYstartdrag = parent.yMouse;
		this.t_y = undefined;
		this.onMouseMove = function () {
			this.x += this.xMouse - this.mouseX;
			this.y += this.yMouse - this.mouseY;
		}
		this.onRelease = function() {
			this.onMouseMove = null;
			if ((this.mouseXstartdrag == parent.xMouse) && (this.mouseYstartdrag == parent.yMouse) && (this.pic.__c != undefined))
				_level0.copyToClipboard (this.pic.__c);
			if (!this.$isTruePlace()) this.$back();
		}
		this.onReleaseOutside = function() {
			this.onMouseMove = null;
			this.$back();
		}
	}
}

function $self () {
	this.useHandCursor = false;
	this.onPress = null;
}

function $hide () {
	if (this.pic.ST_DISABLED != undefined) {
		this.pic.enabled = false;
		if (sys_param("hide_passive") == "true") this.t_alpha = 0; // v4a
	}
	else this.t_alpha = 0;
}

function $show () {
	if (this.pic.ST_DISABLED != undefined) {
		this.pic.enabled = true;
		if (sys_param("hide_passive") == "true") this.t_alpha = 1; // v4a
	}
	else this.t_alpha = 1;
}

function $back () {
	this.t_x = this.x00;
	this.t_y = this.y00;
	this.d_y = undefined;
	this.depth = - this.up.movingThingDepth;
}

function $ref (ref_id, closeFunction) {
	return _level0.gotoRef (ref_id, closeFunction);
}

function $progress (pr) {
	 _level0.progressReport (pr / 100, false);
}

function $enlarge (media_id) {
	for (var e in _level0.myModule.tableIds) {
		var med = _level0.myModule.tableIds[e];
		if (med.tree.attributes.id == media_id) med.tryEnlarge ();
	}
}

function $isOnTarget (th) { //  ,  $th()
	var centerX = this.x + this.width / 2;
	var centerY = this.y + this.height / 2;
	return ((centerX > th.x) && (centerX < (th.x + th.width)) &&
		(centerY > th.y) && (centerY < (th.y + th.height)));
}

function $isOnTargetSid (sid) {
	return $isOnTarget ($ths(sid));
}
