this.tree = null;
this.up = null;
this.elements = new Array ();
this.x_ = 0;
this.y_ = 0;
this.w = 0;
this.h = 0;
this.pagesSub = new Array ();

this.wasDepth = 999;

this.pageType = ""; // abstract

function init (mod, curPage) {
	tree = curPage;
	up = mod;

	design (curPage);

	//    
	var myPage = curPage.childNodes;
	for (var tegN=0; tegN < myPage.length; tegN++) {
		var curTeg = myPage.item(tegN);
		
		switch (curTeg.nodeName) {
		case "frame" :
			//  
			var el = new Composition;
			el._class = "ElemFrame";
			el.name = "ElemFrame" + (--wasDepth);
			el.parent = this;
			el.init (this, curTeg);	
			elements.push (el);
			break;
		case "video" :
			var el = new Composition;
			el._class = "ElemVideo";
			el.name = "ElemVideo" + (--wasDepth);
			el.parent = this;
			el.init (this, curTeg);	
			elements.push (el);
			break;
		case "anime" :
			var el = new Composition;
			el._class = "ElemAnime";
			el.name = "ElemAnime" + (--wasDepth);
			el.parent = this;
			el.init (this, curTeg);	
			elements.push (el);
			break;
		case "interactive" :
			var el = new Composition;
			el._class = "ElemInteractive";
			el.name = "ElemInteractive" + (--wasDepth);
			el.parent = this;
			el.init (this, curTeg);	
			elements.push (el);
			break;
		case "text" :
			var el = new Composition;
			el._class = "ElemText";
			el.name = "ElemText" + (--wasDepth);
			el.parent = this;
			el.init (this, curTeg);	
			elements.push (el);
			break;
		case "subPage" :
			curTeg.attributes.id = curTeg.attributes.type + tree.attributes.id; // interesting1 // v3		
			var cp = new Composition;
			cp._class = "PageSub";
			cp.name = "PageSub" + this.name + curTeg.attributes.type + (--wasDepth);
			cp.parent = this.up;
			cp.init (this, curTeg);	
			pagesSub.push (cp);
			up.pagesRef.push (cp); // v3
			cp.addIcon (this, curTeg, cp);
			break;
		case "thing" :
			var el = new Composition;
			el._class = "ElemThing";
			el.name = "ElemThing" + (--wasDepth);
			el.parent = this;
			el.init (this, curTeg);	
			elements.push (el);
			break;
		case "line" :
			var el = new Composition;
			el._class = "ElemLine";
			el.name = "ElemLine" + (--wasDepth);
			el.parent = this;
			el.init (this, curTeg);	
			elements.push (el);
			break;
		}
	}
	++_global.restToDecor;
}

function design (curPage) {
	if (tree.attributes.width != undefined) w = tree.attributes.width;
	if (tree.attributes.height != undefined) h = tree.attributes.height;
	x_ = (tree.attributes.x != undefined) ? tree.attributes.x : ((_level0.SETUP_SCR_w - w) / 2);
	y_ = (tree.attributes.y != undefined) ? tree.attributes.y : ((_level0.SETUP_SCR_h - h) / 2);
	if ((tree.attributes.width == undefined) && (tree.attributes.height == undefined)) tree.attributes.autosize = true;
}

function formatLines () {
	var stat = "0";
	var dx = 13;
	var dy = 13;
	var el0;
	var elx;
	var ely;
	for (var i = 0; i < elements.length ;i++) {
		var el = elements[i];
		el.preparePic ();
		switch (el.tree.nodeName) {
			case "frame": case "video": case "anime": case "interactive": case "thing":
				switch (stat) {
					case "0":
						if ((el.tree.attributes.x == 0) && (el.tree.attributes.y == 0) && (el.tree.nodeName != "thing")) {
							stat = "y";
							el.x = 362 - el.pic.width;
							el.y = 96;
						} 
						el.decor ();
						el.title_ ();
						elx = ely = el;
						break;
					case "x":
						if (el.pic.wasAutosized == true) {
							el.tree.attributes.width = el.tree.attributes.width * elx.tree.attributes.height / el.tree.attributes.height;
							el.tree.attributes.height = elx.tree.attributes.height;
							el.pic.width = Math.round(el.tree.attributes.width);
							el.pic.height = elx.pic.height;
						}
						el.decor ();
						el.title_ ();
						var bo = el.getBounds(_level0.myModule);
						el.x = elx.x - (bo.xMax - bo.xMin) - dx + 10;
						el.y = elx.y;
						elx = el;
						if (_global.module_version >= 2) { // v2
							if (el.tree.attributes.noFrame == true) el.x -= 10;
						}
						break;
					case "y":
						if (el.pic.wasAutosized == true) {
							el.tree.attributes.height = el.tree.attributes.height * ely.tree.attributes.width / el.tree.attributes.width;
							el.tree.attributes.width = ely.tree.attributes.width;
							el.pic.height = Math.round(el.tree.attributes.height);
							el.pic.width = ely.pic.width;
						}
						el.decor ();
						el.title_ ();
						var bo = ely.getBounds(_level0.myModule);
						el.x = ely.x + ely.pic.width - el.pic.width;
						el.y = bo.yMax + dy - 5;
						if (_global.module_version >= 2) { // v2
							el.y += 6;
							if (el.tree.attributes.noFrame == true) el.y -= 5;
							if ((ely.titleNode == null) || (ely.titleNode.attributes.hide == true)) el.y += 4;
						}
						ely = el;
						break;
				}
				el.tree.attributes.x = el.x;
				el.tree.attributes.y = el.y;
				el0 = el;
				break;
			case "line":
				stat = el.tree.attributes.direct;
				if (stat == undefined) stat = "x";
				switch (stat) {
					case "x":
						if (el.tree.attributes["new"] == true) elx = el0; 
						if (el.tree.attributes.step != undefined) dx = el.tree.attributes.step;
						break;
					case "y":
						if (el.tree.attributes["new"] == true) ely = el0; 
						if (el.tree.attributes.step != undefined) dy = el.tree.attributes.step + 
							((_global.module_version >= 2) ? 0 : 10); // v2
						break;
					case "no":
						stat = "0";
						break;
				}
				break;
			default:
				el.decor ();
				el.title_ ();
		}
	}
	if (this.subpages) this.subpages.depth = --wasDepth;
	--wasDepth;
	this.movingThingDepth = --wasDepth;
	--wasDepth;
	this.thingDepth = --wasDepth;
	--wasDepth;
	if (--_global.restToDecor == 0) _level0.endOfLoadPlus ();
}
