/*	
	step = <step_name> $ <part_sid> [$ <part_sid>]
*/		

this.allSteps = null;
this.thisStep = 0;
this.partsPassed = 0;

function $init () {
	ShCore_$init ();
	allSteps = page.sys_param ("step").split("\n");
}

function reset (fromButtonReset) {
	ShCore_reset ();
	thisStep = 0;
	partsPassed = 0;
	for (var step in allSteps) {
		var parts = allSteps[step].split('$').slice(1);
		for (var i in parts) {
			var part_i = page.$ths(parts[i]);
			part_i.pic.isPart = true;
			part_i.blocked = (step > 0);
			partActivate (part_i, (step == 0));
			part_i.pic._visible = true;
			if (fromButtonReset) part_i.pic.reset();
		}
	} 
}

function allPartPassed (part, isRight) {
	if (!part.passed) {
		part.passed = true;
		++ partsPassed;
		partActivate (part, false);
	}
	var parts = allSteps[thisStep].split('$').slice(1);
	if (partsPassed == parts.length) {
		if ((++ thisStep) == allSteps.length) return true;
		partsPassed = 0;
		parts = allSteps[thisStep].split('$');
		var parts1 = parts.slice(1); // v6
		for (var i in parts1) {
			var part_i = page.$ths(parts1[i]);
			part_i.blocked = false;
			part_i.pic.reset();
			partActivate (part_i, true);
		}
		msg("msg:" + parts[0] + (isRight ? "" : "Bad"), "msg:part" + (isRight ? "" : "Bad"));
		return false;
	}
	msg("msg:part" + (isRight ? "" : "Bad"), "msg:part");
	return false;
}

function calcCounts() {
	trueCount = errCount = 0;
	for (var step in allSteps) {
		var parts = allSteps[step].split('$');
		for (var part in parts) if (part > 0) {
			var partI = page.$ths(parts[part]);
			trueCount += partI.pic.trueCount;
			errCount  += partI.pic.errCount;
		}
	} 	
}

function partActivate (p, beActive) {
	if ((allSteps.length > 1) && (_level0.customColor == undefined)) with (p.pic) {
		var src = _level0.SETUP_PATH_img + 
			(beActive ? ((p.sys_param ('skin') == 'tSkin_empty.png') ? 'tSkin_active.png' : p.sys_param ('skin')) : 'tSkin_empty.png');
		if (imSkin.src != src) {
			imSkin.src = src;
			resize (width, height);
		}
	}
}